/*
* Creació dels rols, usuaris
* Es creen els rols bàsics per assignar els privilegis i els assignem els privilegis 
* S'ha d'estar identificat com a SYS/oracle
*/	

spool ./02_CreacioUsuaris.log;


/*
* es creen els rols
*/
PROMPT 'CREATE ROL admin_rol, user_rol, basic_rol';
CREATE ROLE admin_rol;
CREATE ROLE user_rol;
CREATE ROLE basic_rol;

GRANT CREATE SESSION TO basic_rol;

GRANT CREATE TABLE, CREATE VIEW, CREATE PROCEDURE,CREATE SEQUENCE, CREATE TRIGGER, CREATE TYPE, CREATE SYNONYM, CREATE ANY INDEX, 
      DROP ANY TABLE, DROP ANY VIEW, DROP ANY PROCEDURE,DROP ANY SEQUENCE, DROP ANY TYPE, DROP ANY SYNONYM, DROP ANY INDEX TO admin_rol;


/*
 * creem els perfils dels usuaris
*/

PROMPT 'CREATE PROFILE perfil_TFC';
CREATE PROFILE perfil_TFC LIMIT
SESSIONS_PER_USER 1
CONNECT_TIME UNLIMITED
IDLE_TIME 30
FAILED_LOGIN_ATTEMPTS 3;

/*
* creem els usuaris i els assignem permisos amb el rol i el perfil
* 
*/

PROMPT 'CREATE USER admin_tfc';
CREATE USER admin_tfc IDENTIFIED BY tfc 
DEFAULT TABLESPACE TFC_BD
TEMPORARY TABLESPACE TFC_temp
QUOTA UNLIMITED ON TFC_BD;

PROMPT 'CREATE USER user_tfc';
create user user_tfc IDENTIFIED BY tfc
DEFAULT TABLESPACE TFC_BD
TEMPORARY TABLESPACE TFC_temp
QUOTA UNLIMITED ON TFC_BD;

ALTER USER admin_tfc PROFILE perfil_TFC;
GRANT basic_rol, admin_rol TO admin_tfc;
ALTER USER admin_tfc QUOTA UNLIMITED ON TFC_DWH;
ALTER USER admin_tfc QUOTA UNLIMITED ON TFC_IDX;


ALTER USER user_tfc PROFILE perfil_TFC;
GRANT basic_rol, user_rol TO user_tfc;



spool off;