/*
* Triggers necessaris per implementar els mecanismes d'auditorís de la informació continguda 
* a les taules
*
*/

/* trigger per l'auditoria de la taula de accions
* trigger que es dispara en cada actualització de la columna Valor Vigent de la taula accions
*/
spool ./05_triggers.log;

PROMPT 'CREATE TRIGGER trigHistoricAccions';
CREATE OR REPLACE TRIGGER trigHistoricAccions
AFTER UPDATE OF valorVigent ON accions
FOR EACH ROW
WHEN (new.valorVigent > 0)
DECLARE

-- declaració de variables locals del procediment
	prc_nom varchar2(35 CHAR):='TRIGGER_HISTORICACCIONS';
	prc_paramIN varchar(100 CHAR) := null;
	sError varchar(512);
	var_valdefecte accions.valorVigent%type;
	
BEGIN

--si el valor anterior no és null s'actualitza el registre, si és null es posa valor 0
	var_valdefecte := NVL (:old.valorVigent, 0);

/*	DBMS_OUTPUT.PUT_LINE ('Old : ' || :old.valorVigent);
    DBMS_OUTPUT.PUT_LINE ('New : ' || :new.valorVigent);*/
 
--actualitza la taula historic accions SI EL VALOR ÉS DIFERENT
	IF (:new.valorVigent != :old.valorVigent ) THEN
	INSERT INTO historicAccions (idHistoricAccio, accio, valorVell, valorNou, dataInici)
		VALUES ( historicAccions_seq.nextval, :new.idAccio, var_valdefecte, :new.valorVigent, sysdate);

	-- inserció a la taula Log
	insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
		values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'FI OK', 'FI OK');
	END IF;

	-- inserció a la taula Log
	insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
		values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'Error', 'FI OK');


	EXCEPTION

		WHEN OTHERS THEN
			sError := 'Error: actualitzacio del valor accio no realitzat '||substr(SQLERRM, 1, 500);    
		    insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
				values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'Error', sError);
   			 
			RAISE;

END;
/

/* trigger per l'auditoria de la taula cartera
* trigger que es dispara en cada actualització de la columna quantitat de la taula cartera
*/
PROMPT 'CREATE TRIGGER trigHistoricCartera';
CREATE OR REPLACE TRIGGER trigHistoricCartera
AFTER INSERT OR UPDATE OF quantitat, valorTotal ON cartera
FOR EACH ROW
DECLARE

-- declaració de variables locals del procediment
	prc_nom varchar2(35 CHAR):='TRIGGER_HISTORICCARTERA';
	prc_paramIN varchar(100 CHAR) := null;
	sError varchar(512);
	var_valdefecte cartera.quantitat%type;
	
BEGIN

--si el valor anterior no és null s'actualitza el registre, si és null es posa valor 0
	var_valdefecte := NVL (:old.quantitat, 0);

/*	DBMS_OUTPUT.PUT_LINE ('Old : ' || :old.quantitat);
    DBMS_OUTPUT.PUT_LINE ('New : ' || :new.quantitat);*/
 
--actualitza la taula historic accions   
	INSERT INTO historicCartera (idHistoricCartera, cartera, quantitat, ValorTotal, dataInici)
		VALUES ( historicCartera_seq.nextval, :new.idCartera, :new.quantitat, :new.valorTotal, CURRENT_TIMESTAMP);

	-- inserció a la taula Log
	insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
		values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'FI OK', 'FI OK');
	

	EXCEPTION

		WHEN OTHERS THEN
			sError := 'Error: actualitzacio del valor cartera no realitzat '||substr(SQLERRM, 1, 500);    
		    insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
				values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'Error', sError);
   			 
			RAISE;

END;
/

/* trigger per manteniment TD_Clients
* trigger que es dispara en cada inserció d'un nou client
*/
PROMPT 'CREATE TRIGGER trigAltaClients';
CREATE OR REPLACE TRIGGER trigAltaClients
AFTER INSERT ON clients
FOR EACH ROW
DECLARE

-- declaració de variables locals del procediment
	prc_nom varchar2(35 CHAR):='TRIGGER_ALTACLIENTS';
	prc_paramIN varchar(100 CHAR) := null;
	sError varchar(512);
		
BEGIN


--actualitza la taula TD_Clients   
	INSERT INTO TD_Clients (idClient, nomClient)
		VALUES (:new.idClient, :new.nomClient);

--registra a la taula Log l'execució del procediment
	insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
		values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'FI OK', 'FI OK');



	EXCEPTION

		WHEN OTHERS THEN
			sError := 'Error: actualitzacio del valor TD_clients '||substr(SQLERRM, 1, 500);    
			insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
				values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'Error', sError);
   			 
			RAISE;

END;
/

/* trigger per manteniment TD_Accions
* trigger que es dispara en cada inserció d'una nova accio
*/
PROMPT 'CREATE TRIGGER trigAltaAccions';
CREATE OR REPLACE TRIGGER trigAltaAccions
AFTER INSERT ON accions
FOR EACH ROW
DECLARE

-- declaració de variables locals del procediment
	prc_nom varchar2(35 CHAR):='TRIGGER_ALTAACCIONS';
	prc_paramIN varchar(100 CHAR) := null;
	sError varchar(512);
		
BEGIN


--actualitza la taula TD_Accions  
	INSERT INTO TD_Accions (idaccio, ticker, nomaccio)
		VALUES (:new.idAccio, :new.ticker, :new.nomaccio);

--registra a la taula Log l'execució del procediment
	insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
		values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'FI OK', 'FI OK');




	EXCEPTION

		WHEN OTHERS THEN
			sError := 'Error: actualitzacio del valor TD_Accions '||substr(SQLERRM, 1, 500);    
		    insert into log_procediments (idLog, nomprocediment, tempsExecucio, parametresin, finalitzacio, finalitzacioTxt)
				values (LOG_PROCEDIMENTS_SEQ.NEXTVAL, prc_nom, CURRENT_TIMESTAMP, prc_paramIN, 'Error', sError);   			 
			RAISE;

END;
/

spool off;