set pagesize 5000
set linesize 110
set serveroutput on
set term off
set wrap off




-- executar com a user_tfc/tfc

spool ./08_test_ABM1.log;

PROMPT '-----------------------------------';
PROMPT 'PROCEDIMENTS ALTA/BAIXA/MODIFICACIO';
PROMPT '-----------------------------------';

-- definim la variable OUT
variable varOut varchar2(255 char);

/*
* pkg_control
*/

-- inserci de valors en la taula mercats
PROMPT '-- inserci de valors en la taula mercats --';
exec admin_tfc.pkg_control.prc_mercat_alta ('IBEX35', :varOut);
exec admin_tfc.pkg_control.prc_mercat_alta ('BEL20', :varOut);
exec admin_tfc.pkg_control.prc_mercat_alta ('EURO STOXX 50', :varOut);
exec admin_tfc.pkg_control.prc_mercat_alta ('DOW JONES', :varOut);
exec admin_tfc.pkg_control.prc_mercat_alta ('NASDAQ 100', :varOut);


/*
* pkg_clients
*/ 
PROMPT '--- ABM CLIENTS ---';
PROMPT '-------------------';
-- prc_client_alta
-- inserci de nous clients
PROMPT 'Alta nous clients: ';
exec admin_tfc.pkg_clients.prc_client_alta ('pep','casadevall i masoliver', '77999888A', 'pep@pep.com', '678912345', :varOut);
print :varOut;
exec admin_tfc.pkg_clients.prc_client_alta ('joan','casademunt i masperer', '77888999a', 'joan@joan.com', '789123456', :varOut);
print :varOut;
exec admin_tfc.pkg_clients.prc_client_alta ('josep','casamitjana i maspomer', '77898898a', 'josep@josep.com', '891234567', :varOut);
print :varOut;
exec admin_tfc.pkg_clients.prc_client_alta ('miquel','casadall i masferrer', '77989989a', 'miquel@miquel.com', '912345678', :varOut);
print :varOut;
exec admin_tfc.pkg_clients.prc_client_alta ('pere','casadaqu i masfuster', '77666555a', 'pere@pere.com', '123456789', :varOut);
print :varOut;
-- es prova donar d'alta un client que ja existeix
PROMPT 'Intent alta de client existent: ';
exec admin_tfc.pkg_clients.prc_client_alta ('pep','casadevall i masoliver', '77999888A', 'pep@pep.com', '678912345', :varOut);
print :varOut;
PROMPT 'Intent alta de client passant camp clau null: ';
exec admin_tfc.pkg_clients.prc_client_alta ('','casadevall i masoliver', '77999888A', 'pep@pep.com', '678912345', :varOut);
print :varOut;

PROMPT 'Es continua inserint nous clients: ';
-- es continua amb les insercions de clients
exec admin_tfc.pkg_clients.prc_client_alta  ('Aleix','casagran i masviader', '77555666a', 'aleix@aleix.com', '234567891', :varOut);
print :varOut;
exec admin_tfc.pkg_clients.prc_client_alta  ('jaume','casapetita i masgranjer', '77656656a', 'jaume@jaume.com', '345678912', :varOut);
print :varOut;
exec admin_tfc.pkg_clients.prc_client_alta  ('salvador','casadelmig i maslleter', '77565565a', 'salvador@salvador.com', '456789123', :varOut);
print :varOut;
exec admin_tfc.pkg_clients.prc_client_alta  ('emili','casapobre i massurer', '77456456a', 'emili@emili.com', '567891234', :varOut);
print :varOut;
exec admin_tfc.pkg_clients.prc_client_alta  ('marc','casarica i mascaador', '77654654a', 'marc@marc.com', '5678912344', :varOut);
print :varOut;

PROMPT 'Situacio taula clients: ';
COLUMN nomclient FORMAT A10
COLUMN cognoms FORMAT A25
COLUMN nif FORMAT A10
COLUMN CORREUELECTRONIC FORMAT A25
COLUMN telefon FORMAT A10
COLUMN esactiu FORMAT A5


select * from admin_tfc.clients order by idclient;
-- prc_client_modificacio
-- es modifica un client 
PROMPT 'Modificacio de client: ';
exec admin_tfc.pkg_clients.prc_client_modificacio (10, 'enric', '', '99777666B', 'enric@enric.com', '', :varOut);
print :varOut;

PROMPT 'Intent modificacio de client passant identificador inexistent: ';
exec admin_tfc.pkg_clients.prc_client_modificacio (999999, 'enric', '', '99777666B', 'enric@enric.com', '', :varOut);
print :varOut;

PROMPT 'Intent modificacio de client passant id null: ';
exec admin_tfc.pkg_clients.prc_client_modificacio ('', 'enric', '', '99777666B', 'enric@enric.com', '', :varOut);
print :varOut;


-- prc_client_baixa
-- es dona de baixa un client passant el nif
PROMPT 'Baixa client per nif: ';
exec admin_tfc.pkg_clients.prc_client_baixa ('77555666a', :varOut);
print :varOut;

PROMPT 'Intent baixa de client passant identificador inexistent: ';
exec admin_tfc.pkg_clients.prc_client_baixa ('99999999x', :varOut);
print :varOut;

PROMPT 'Intent baixa de client passant identificador null: ';
exec admin_tfc.pkg_clients.prc_client_baixa ('', :varOut);
print :varOut;

PROMPT 'Situacio taula clients: ';
select * from admin_tfc.clients order by idclient;

/*
* pkg_accions
*/

PROMPT '--- ABM ACCIONS ---';
PROMPT '-------------------';
-- prc_accio_alta
-- es donen d'alta diverses accions
PROMPT 'Alta noves accions: ';
exec admin_tfc.pkg_accions.prc_accio_alta ('ABI', 'ABELTIS', 2, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('ABG', 'ABENGOA', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('ANA', 'ACCIONA', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('ACS', 'ACS ACTIVIDADES, CONTRUCCIONES Y SERVICIOS', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('MTS', 'ARCELORMITTAL', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('SAN', 'BANCO SANTANDER', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('BKIA', 'BANKIA', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('FCC', 'FOMENTO DE CONSTRUCCIONES Y CONTRATAS', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('GAS', 'GAS NATURAL SDG', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('IBE', 'IBERDROLA', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('JAZ', 'JAZZTEL', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('TL5', 'MEDIASET ESPAA COMUNICACION', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('SCYR', 'SACYR', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('TEF', 'TELEFONICA', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('SAB', 'BANC SABADELL', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('ITX', 'INDITEX', 1, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_alta ('GRF', 'GRIFOLS', 1, :varOut);
print :varOut;

-- es prova donar d'alta una accio que ja existeix
PROMPT 'Intent alta accio ja existent: ' ;
exec admin_tfc.pkg_accions.prc_accio_alta ('ABI', 'ABERTIS', 1, :varOut);
print :varOut;


-- prc_accio_modificacio
-- es modifica el ticker, el nom i el mercat d'una de les accions
PROMPT 'Modificacio accio: ';
COLUMN ticker FORMAT A10
COLUMN nomaccio FORMAT A20
COLUMN valorvigent FORMAT 90.990


select * from admin_tfc.accions where ticker = 'ABI';
exec admin_tfc.pkg_accions.prc_accio_modificacio (1, 'ABE', 'ABERTIS', 1, :varOut);
print :varOut;
select * from admin_tfc.accions where ticker = 'ABE';

-- intent modificaci accio inexistent
PROMPT 'Intent modificaci accio passant identificador inexistent: '
exec admin_tfc.pkg_accions.prc_accio_modificacio (666, 'TEF', 'TEFLONICA', 1, :varOut);
print :varOut;

PROMPT 'Intent modificaci accio passant id null: '
exec admin_tfc.pkg_accions.prc_accio_modificacio ('', 'TEF', 'TEFLONICA', 1, :varOut);
print :varOut;

-- PRC_ACCIO_BAIXA
-- es dna de baixa una de les accions
PROMPT 'Baixa accio';
exec admin_tfc.pkg_accions.prc_accio_baixa ('TEF', :varOut);
print :varOut;

-- intent baixa accio inexistent
PROMPT 'Intent baixa accio passant identificador inexistent: ';
exec admin_tfc.pkg_accions.prc_accio_baixa ('PEP', :varOut);
print :varOut;


-- intent modificaci accio inactiva
PROMPT 'Intent modificaci accio inactiva: '
exec admin_tfc.pkg_accions.prc_accio_modificacio (14, 'TEF', 'TEFLONICA', 1, :varOut);
print :varOut;


-- prc_accio_preu
-- volem assignar el preu de la accio

PROMPT 'Assignacio de preus: ' ;
exec admin_tfc.pkg_accions.prc_accio_preu ('ABG',2.957, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('ABE',16.42, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('ANA',72.22, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('ACS',31.25, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('MTS',10.255, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('SAN',6.73, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('BKIA',1.235, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('FCC',11.025, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('GAS',22.245, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('IBE',6.187, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('JAZ',12.885, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('SCYR',4.181, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('TL5',12.02, :varOut);
print :varOut;
-- volem modificar el preu d'una acci inactiva
PROMPT 'Intent assignacio de preu a accio no activa: ' ;
exec admin_tfc.pkg_accions.prc_accio_preu ('TEF',13.165, :varOut);
print :varOut;
-- es passa un id/ticker incorrecte per l'acci que es vol canviar de preu
PROMPT 'Intent assignacio de preu a una accio passant identificador inexistent';
exec admin_tfc.pkg_accions.prc_accio_preu ('PEP',99.99, :varOut);
print :varOut;

PROMPT 'Intent assignacio de preu passant id null';
exec admin_tfc.pkg_accions.prc_accio_preu ('',99.99, :varOut);
print :varOut;
-- es continua amb la inserci de preus
PROMPT 'Continua assignant preus: ';
exec admin_tfc.pkg_accions.prc_accio_preu ('SAB',2.3930, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('ITX',28.94, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('GRF',36.32, :varOut);
print :varOut;

PROMPT 'situacio taula accions: ';

select * from admin_tfc.accions order by idaccio;

-- volem assignar nous preus a una accio
PROMPT 'Assignacio de nous preus / modificacio';
exec admin_tfc.pkg_accions.prc_accio_preu ('ABG',3.251, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('ABE',17.51, :varOut);
print :varOut;
exec admin_tfc.pkg_accions.prc_accio_preu ('ANA',71.22, :varOut);
print :varOut;

select * from admin_tfc.accions order by idaccio;

commit;

spool off;
