#!/bin/bash
echo "Programa d'instal.lació de BD gestió de carteres"
echo "per Josep Unyó 15-06-15"
echo

if [ $# -ne 2 ]
then
	echo " Nombre invàlid de paràmetres"
	echo " has de posar el nom de l'usuari administrador DBA i el seu password"
	echo " pex instal_tot.sh SYS oracle"
	exit
fi

# variables que contenen l'administrador
administrador=$1
claudepas=$2

echo  "s'utilitzarà l'usuari SYSDBA" $administrador"/"$claudepas
echo 
echo "Fase 1: borrar la BD per reiniciar la instal.lació de zero....."
echo
sqlplus admin_tfc/tfc@XE<< BORRA_PKG > ./out1_borraPkg.log
drop package pkg_accions;
drop package pkg_control;
drop package pkg_cartera;
drop package pkg_clients;
drop package pkg_consultes;
drop package pkg_consultes_dwh;
drop package pkg_dwh;
drop package pkg_ordre;
drop package pkg_utils;
BORRA_PKG

sqlplus admin_tfc/tfc@XE<< BORRA_TAULES > ./out2_borraTaules.log
drop index TF_CARTERAVALORS_IDX;
drop index TF_ACCIOMESNEGOCIADA_IDX;
drop table ORDRES CASCADE CONSTRAINTS PURGE;
drop table HISTORICACCIONS CASCADE CONSTRAINTS PURGE;
drop table HISTORICCARTERA CASCADE CONSTRAINTS PURGE;
drop table CARTERA CASCADE CONSTRAINTS PURGE;
drop table ACCIONS CASCADE CONSTRAINTS PURGE;
drop table MERCATS CASCADE CONSTRAINTS PURGE;
drop table CLIENTS CASCADE CONSTRAINTS PURGE;
drop table TD_TEMPS CASCADE CONSTRAINTS PURGE;
drop table TD_CLIENTS CASCADE CONSTRAINTS PURGE;
drop table TD_ACCIONS CASCADE CONSTRAINTS PURGE;
drop table TF_BENEFICIS CASCADE CONSTRAINTS PURGE;
drop table TF_CARTERAVALORS CASCADE CONSTRAINTS PURGE;
drop table TF_ACCIOMESNEGOCIADA CASCADE CONSTRAINTS PURGE;
drop table TF_ACCIONSDISPONIBLES CASCADE CONSTRAINTS PURGE;
drop table LOG_PROCEDIMENTS CASCADE CONSTRAINTS PURGE;
drop table ERRORS_RECONEGUTS CASCADE CONSTRAINTS PURGE;
drop sequence log_procediments_seq;
drop sequence clients_seq;
drop sequence mercats_seq;
drop sequence accions_seq;
drop sequence cartera_seq;
drop sequence ordres_seq;
drop sequence historicAccions_seq;
drop sequence historicCartera_seq;
BORRA_TAULES


sqlplus SYS/oracle@XE as SYSDBA<< BORRA_TS > ./out3_borraTS.log
DROP USER admin_tfc cascade;
DROP USER user_tfc cascade;
DROP ROLE admin_rol;
DROP ROLE user_rol;
DROP ROLE basic_rol;
DROP PROFILE perfil_TFC CASCADE;
DROP TABLESPACE TFC_BD INCLUDING CONTENTS AND DATAFILES CASCADE CONSTRAINTS;
DROP TABLESPACE TFC_DWH INCLUDING CONTENTS AND DATAFILES CASCADE CONSTRAINTS;
DROP TABLESPACE TFC_IDX INCLUDING CONTENTS AND DATAFILES CASCADE CONSTRAINTS;
DROP TABLESPACE TFC_temp INCLUDING CONTENTS AND DATAFILES CASCADE CONSTRAINTS;
DROP TABLESPACE TFC_UNDO INCLUDING CONTENTS AND DATAFILES CASCADE CONSTRAINTS;
BORRA_TS

echo "Fase 2: inici de la instal.lació..............................."
echo
# sqlplus SYS/oracle@XE as SYSDBA<< INSTAL_TS > ./out4_instal_TS.log
sqlplus $administrador/$claudepas@XE as SYSDBA<< INSTAL_TS > ./out4_instal_TS.log
@./01_CreacioTablespace.sql
@./02_CreacioUsuaris.sql
INSTAL_TS


sqlplus admin_tfc/tfc@XE<< TAULES > ./out5_taules.log
@./03_CreacioTaules.sql
@./04_CreacioSequencies.sql
@./05_triggers.sql
@./045_index.sql
TAULES

sqlplus admin_tfc/tfc@XE<< PKGS > ./out7_pkgs.log
@./pkg_control.sql
@./pkg_dwh.sql
@./pkg_cartera.sql
@./pkg_ordres.sql
@./pkg_accions.sql
@./pkg_clients.sql
@./pkg_consultes.sql
@./pkg_consultes_DWH.sql
@./pkg_utils.sql
PKGS

# sqlplus SYS/oracle@XE as SYSDBA<< GRANT_USER > ./out6_permisos.log
sqlplus $administrador/$claudepas@XE as SYSDBA<< GRANT_USER > ./out6_permisos.log
@./06_permisos_user.sql
GRANT_USER


echo
echo "S'han generat els fitxer log de la instal.lacio:"
ls *.log
echo
echo
echo "Instal.lacio finalitzada"
echo

exit



