/*
* Paquet de control
* 
*/

spool ./pkg_utils.log;

-- caçalera del paquet
create or replace package pkg_utils is

-- procediment per carregar dades massivament a les taules. Només útil en fase de depuració 
PROCEDURE prc_carrega(
	pClient NUMBER,
	pAccio NUMBER,
	pQuantitat NUMBER,
	pPreuObtingut NUMBER, 
	PdataExecucio date, 
	pTipus VARCHAR2
	) ;

end pkg_utils;
/ 
-- es compila primer la capçalera i després el cos

-- cos del paquet
create or replace package body pkg_utils is

-- definicio del procediment de càrrega massiva de dades. No té utilitat en explotació només serveix per carregar dades
-- i poder realitzar proves estadístiques
PROCEDURE prc_carrega(
	pClient NUMBER,
	pAccio NUMBER,
	pQuantitat NUMBER,
	pPreuObtingut NUMBER, 
	PdataExecucio date, 
	pTipus VARCHAR2
	) is
-- declaracio de variables locals
	numAccions cartera.quantitat%type;
	sError varchar(512);
	var_dia NUMBER(8);
	var_quantitat NUMBER(6);
	var_numClients NUMBER (6);
	var_ultimSeq NUMBER (6);

	var_dataIni TIMESTAMP;
	var_dataFi TIMESTAMP;

	var_valor1er NUMBER(8);
	var_valor2on NUMBER(8);
	var_beneficiNet NUMBER(8);
	var_x100Benef NUMBER(5,2);
	
	CURSOR cursorNumOperacions
		IS
			SELECT C1.*
				FROM (
					SELECT O.ACCIO, COUNT(*) AS QTAT
					FROM  ORDRES O
					WHERE O.ESTAT = 'EX'
					GROUP BY O.ACCIO ) C1
				JOIN (
					SELECT MAX (C2.QTAT) AS TOPVALOR
					FROM (SELECT O2.ACCIO, COUNT(*) AS QTAT
						FROM ORDRES O2
						WHERE O2.ESTAT = 'EX'
						GROUP BY O2.ACCIO) C2)C3
				ON C1.QTAT = C3.TOPVALOR;

	CURSOR cursorValorMaxCartera
		IS
			SELECT C1.*
				FROM (
					SELECT CA.CLIENT, SUM(QUANTITAT) AS QTAT, SUM(VALORTOTAL) AS VALOR
					FROM CARTERA CA
					GROUP BY CA.CLIENT
				) C1
				JOIN (
					SELECT MAX(C2.VALOR) AS MAXVALOR
					FROM (SELECT CA2.CLIENT, SUM(QUANTITAT) AS QTAT, SUM(VALORTOTAL) AS VALOR
					      FROM CARTERA CA2
					      GROUP BY CA2.CLIENT) C2)C3
				ON C1.VALOR=C3.MAXVALOR;

	CURSOR cursorClientsCartera
		IS
			select distinct client
			from cartera; 

		VAR_PARAM VARCHAR2(100 CHAR);
BEGIN

	VAR_PARAM := pClient||', '||pAccio||', '||pQuantitat||', '||pPreuObtingut||', '||PdataExecucio||', '||pTipus;

	if pTipus = 'C' then

		INSERT INTO ordres (idordre, client, accio, dataentrada, tipus, origen, estat, preuobjectiu, preuObtingut, quantitat, dataExecucio, total)
			VALUES (ordres_seq.nextval, pClient, pAccio, PdataExecucio-30, 'COMPRA', 'AUT', 'EX', pPreuObtingut,  pPreuObtingut - pPreuObtingut*0.1, pQuantitat, PdataExecucio, pQuantitat*pPreuObtingut);



		admin_tfc.pkg_cartera.prc_cartera_adjudicar(pClient, pAccio, pQuantitat, pPreuObtingut, sError);

		select idcartera
			into var_ultimSeq
			from cartera where client = pClient and accio = pAccio;

		DBMS_OUTPUT.PUT_LINE('INSERCIO: ' || VAR_PARAM);
		DBMS_OUTPUT.PUT_LINE('ID CARTERA: ' || var_ultimSeq);

		select quantitat
				into numAccions
				from cartera
				WHERE client = pClient and accio = pAccio;


		INSERT INTO historiccartera (idhistoriccartera, cartera, quantitat, valortotal, datainici)
			VALUES (historiccartera_seq.nextval, var_ultimSeq, pQuantitat+numAccions, (pQuantitat+numAccions)*pPreuObtingut, PdataExecucio );



	elsif pTipus = 'V' THEN
		INSERT INTO ordres (idordre, client, accio, dataentrada, tipus, origen, estat, preuobjectiu, preuObtingut, quantitat, dataExecucio, total)
			VALUES (ordres_seq.nextval, pClient, pAccio, PdataExecucio-30, 'VENDA', 'MAN', 'EX', pPreuObtingut,  pPreuObtingut - pPreuObtingut*0.1, pQuantitat, PdataExecucio, pQuantitat*pPreuObtingut);

		admin_tfc.pkg_cartera.prc_cartera_retirar(pClient, pAccio, pQuantitat,  pPreuObtingut, sError);

		select idcartera
			into var_ultimSeq
			from cartera where client = pClient and accio = pAccio;
		
		DBMS_OUTPUT.PUT_LINE('INSERCIO: ' || VAR_PARAM);
		DBMS_OUTPUT.PUT_LINE('ID CARTERA: ' || var_ultimSeq);

		select quantitat
				into numAccions
				from cartera
				WHERE client = pClient and accio = pAccio;

		INSERT INTO historiccartera (idhistoriccartera, cartera, quantitat, valortotal, datainici)
			VALUES (historiccartera_seq.nextval, var_ultimSeq, numAccions- pQuantitat, (numAccions - pQuantitat)*pPreuObtingut, PdataExecucio );


	end if;

	var_dia := pkg_dwh.fun_insDim_tdTemps(PdataExecucio);


-- tf_accions_disponibles
	select SUM(quantitat)
		into var_quantitat
		from ordres
		where estat = 'PD' and tipus ='VENDA' and accio = pAccio
		;

	select count (*)
		into var_numClients
		from cartera
		where accio = pAccio
		;

	
	var_quantitat := NVL (var_quantitat, 0);
	var_numClients := NVL (var_numClients, 0);

	INSERT INTO TF_AccionsDisponibles (idtemps, idaccio, numAccionsEnVenda, numClients)
		VALUES (var_dia, pAccio, var_quantitat, var_numClients);

-- s'actualitza la taula TF_acciomesNegociada del mòdul estadístic
	
	
	FOR reg_numOp IN cursorNumOperacions
		LOOP
			BEGIN
				INSERT INTO TF_accioMesNegociada (idTemps, idAccio, numOperacions)
					VALUES (var_dia, reg_numOp.accio, reg_numOp.qtat );
				
			EXCEPTION
					WHEN DUP_VAL_ON_INDEX THEN
						UPDATE TF_accioMesNegociada
							SET numOperacions = reg_numOp.qtat
							WHERE idtemps = var_dia AND idaccio = reg_numOp.accio;
			END;
			DBMS_OUTPUT.PUT_LINE('cursorNumOperacions: ' || reg_numOp.accio||', '||reg_numOp.qtat);

		END LOOP;

-- s'actualitza la taula TF_carteraValor del mòdul estadístic
	FOR reg_valCartera IN cursorValorMaxCartera
	LOOP
		BEGIN
			INSERT INTO TF_carteraValors (idTemps, idClient, numaccions, valorcartera)
				VALUES (var_dia, reg_valCartera.client, reg_valCartera.qtat, reg_valCartera.valor);
		EXCEPTION
				WHEN DUP_VAL_ON_INDEX THEN
					UPDATE TF_carteraValors
						SET numaccions = reg_valCartera.qtat, valorcartera = reg_valCartera.valor
						WHERE idtemps = var_dia AND idClient = reg_valCartera.client;
		END;
		DBMS_OUTPUT.PUT_LINE('cursorValorMaxCartera: ' ||reg_valCartera.client||', '|| reg_valCartera.qtat||', '||reg_valCartera.valor);
	END LOOP;

-- s'actualitza la taula TF_beneficis del mòdul estadístic
	FOR reg_clientCartera IN cursorClientsCartera
	LOOP
		select MIN(hc.datainici)
			INTO var_dataIni
		  from historiccartera hc
		  join
		  cartera ca
		    on hc.cartera = ca.idcartera
		  WHERE HC.DATAINICI BETWEEN TRUNC(PdataExecucio, 'MM') AND PdataExecucio
		  and ca.client = reg_clientCartera.client;

		select MAX(hc.datainici)
			INTO var_dataFi
		  from historiccartera hc
		  join
		  cartera ca
		    on hc.cartera = ca.idcartera
		  WHERE HC.DATAINICI BETWEEN TRUNC(PdataExecucio, 'MM') AND PdataExecucio
		  and ca.client = reg_clientCartera.client;


		IF var_dataIni IS NOT NULL 
		THEN

			select valorTotal
				into var_valor1er
				from historiccartera
				where datainici = var_dataIni ;

				
			IF var_dataFi IS NOT NULL and var_dataFi <> var_dataIni
			THEN

				select valorTotal
					into var_valor2on
					from historiccartera
					where datainici = var_dataFi;

			
				var_beneficiNet := var_valor2on - var_valor1er;
				var_x100Benef := ((var_beneficiNet)/var_valor1er)*100;
			
				BEGIN

					INSERT INTO TF_beneficis (idtemps, idclient, beneficinet, x100benefici)
						VALUES (var_dia, reg_clientCartera.client,var_beneficiNet, var_x100Benef);
				EXCEPTION
					WHEN DUP_VAL_ON_INDEX THEN
						UPDATE TF_beneficis
							SET beneficinet = var_beneficiNet, x100benefici = var_x100Benef
							WHERE idtemps = var_dia AND idClient = reg_clientCartera.client;

				END;	

			ELSE 

				BEGIN

					INSERT INTO TF_beneficis (idtemps, idclient, beneficinet, x100benefici)
						VALUES (var_dia, reg_clientCartera.client,var_valor1er, 100);
				EXCEPTION
					WHEN DUP_VAL_ON_INDEX THEN
						UPDATE TF_beneficis
							SET beneficinet = var_valor1er, x100benefici = 100
							WHERE idtemps = var_dia AND idClient = reg_clientCartera.client;

				END;	



			END IF;


		ELSIF var_dataFi IS NOT NULL
			THEN

			select valorTotal
				into var_valor2on
				from historiccartera
				where datainici = var_dataFi;

			BEGIN

					INSERT INTO TF_beneficis (idtemps, idclient, beneficinet, x100benefici)
						VALUES (var_dia, reg_clientCartera.client,var_valor2on, 100);
			EXCEPTION
				WHEN DUP_VAL_ON_INDEX THEN
					UPDATE TF_beneficis
						SET beneficinet = var_valor2on, x100benefici = 100
						WHERE idtemps = var_dia AND idClient = reg_clientCartera.client;

			END;

		END IF;

	
	END LOOP;


EXCEPTION
	WHEN OTHERS THEN
		DBMS_OUTPUT.PUT_LINE ('HA FALLAT LA CARREGA MASSIVA '||substr(SQLERRM, 1, 500));


end prc_carrega;


end pkg_utils;
/

spool off;